package cn.timer.api.controller.xcgl;

import java.text.ParseException;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class SalaryTool {
	static SimpleDateFormat mat = new SimpleDateFormat("yyyy-MM-dd");
	
	public static Date strToDateLong(String strDate) {
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		ParsePosition pos = new ParsePosition(0);
		Date strtodate = formatter.parse(strDate, pos);
		return strtodate;
	}
	
	// 上个月
		public static String getfirstlastTwo(String time) {
			String firstnext;
			Calendar c1 = Calendar.getInstance();
			c1.setTime(strToDateLong(time)); // 设置为当前时间
			c1.add(Calendar.MONTH, -1);
			c1.set(Calendar.DAY_OF_MONTH, 1);
			firstnext = mat.format(c1.getTime());
			return firstnext;
		}
		public static String getlastlastTwo(String time) {
			String lastnext;
			Calendar ca1 = Calendar.getInstance();
			ca1.setTime(strToDateLong(time)); // 设置为当前时间
			ca1.add(Calendar.MONTH, -1);
			ca1.set(Calendar.DAY_OF_MONTH, ca1.getActualMaximum(Calendar.DAY_OF_MONTH));
			lastnext = mat.format(ca1.getTime());
			return lastnext;
		}
		
		// 本月
		public static String getfirstnowTwo(String time) {
			String firstnow;
			Calendar c = Calendar.getInstance();
			c.setTime(strToDateLong(time)); // 设置为当前时间
			c.add(Calendar.MONTH, 0);
			c.set(Calendar.DAY_OF_MONTH, 1);
			firstnow = mat.format(c.getTime());
			return firstnow;
		}
		public static String getlastnowTwo(String time) {
			String lastnow;
			Calendar ca = Calendar.getInstance();
			ca.setTime(strToDateLong(time)); // 设置为当前时间
			ca.set(Calendar.DAY_OF_MONTH, ca.getActualMaximum(Calendar.DAY_OF_MONTH));
			lastnow = mat.format(ca.getTime());
			return lastnow;
		}
		
		// 下个月
		public static String getfirstnextTwo(String time) {
			String firstnext;
			Calendar c1 = Calendar.getInstance();
			c1.setTime(strToDateLong(time)); // 设置为当前时间
			c1.add(Calendar.MONTH, 1);
			c1.set(Calendar.DAY_OF_MONTH, 1);
			firstnext = mat.format(c1.getTime());
			return firstnext;
		}
		public static String getlastnextTwo(String time) {
			String lastnext;
			Calendar ca1 = Calendar.getInstance();
			ca1.setTime(strToDateLong(time)); // 设置为当前时间
			ca1.add(Calendar.MONTH, 1);
			ca1.set(Calendar.DAY_OF_MONTH, ca1.getActualMaximum(Calendar.DAY_OF_MONTH));
			lastnext = mat.format(ca1.getTime());
			return lastnext;
		}
		
		/**
	     * 	根据 年、月 获取对应的月份 的 天数
	     */
		 public static int getDaysByYearMonth(int year, int month)
		 {
		     Calendar a = Calendar.getInstance();
		     a.set(Calendar.YEAR, year);
		     a.set(Calendar.MONTH, month - 1);
		     a.set(Calendar.DATE, 1);
		     a.roll(Calendar.DATE, -1);
		     int maxDate = a.get(Calendar.DATE);
		     return maxDate;
		 }
		
		 /**
		 *	 获取月份起始日期
		 * 
		 * @param date
		 * @return
		 * @throws ParseException
		 */
		public static String getMinMonthDate(String date) throws ParseException {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(mat.parse(date));
			calendar.set(Calendar.DAY_OF_MONTH,
					calendar.getActualMinimum(Calendar.DAY_OF_MONTH));
			return mat.format(calendar.getTime());
		}

		/**
		 *	 获取月份最后日期
		 * 
		 * @param date
		 * @return
		 * @throws ParseException
		 */
		public static String getMaxMonthDate(String date) throws ParseException {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(mat.parse(date));
			calendar.set(Calendar.DAY_OF_MONTH,
					calendar.getActualMaximum(Calendar.DAY_OF_MONTH));
			return mat.format(calendar.getTime());
		}
		
	//##################################################################################################################################
	
	// 上个月
	public static String getfirstlast() {
		String firstnext;
		Calendar c1 = Calendar.getInstance();
		c1.add(Calendar.MONTH, -1);
		c1.set(Calendar.DAY_OF_MONTH, 1);
		firstnext = mat.format(c1.getTime());
		return firstnext;
	}

	public static String getlastlast() {
		String lastnext;
		Calendar ca1 = Calendar.getInstance();
		ca1.add(Calendar.MONTH, -1);
		ca1.set(Calendar.DAY_OF_MONTH, ca1.getActualMaximum(Calendar.DAY_OF_MONTH));
		lastnext = mat.format(ca1.getTime());
		return lastnext;
	}

	// 本月
	public static String getfirstnow() {
		String firstnow;
		Calendar c = Calendar.getInstance();
		c.add(Calendar.MONTH, 0);
		c.set(Calendar.DAY_OF_MONTH, 1);
		firstnow = mat.format(c.getTime());
		return firstnow;
	}

	public static String getlastnow() {
		String lastnow;
		Calendar ca = Calendar.getInstance();
		ca.set(Calendar.DAY_OF_MONTH, ca.getActualMaximum(Calendar.DAY_OF_MONTH));
		lastnow = mat.format(ca.getTime());
		return lastnow;
	}

	// 下个月
	public static String getfirstnext() {
		String firstnext;
		Calendar c1 = Calendar.getInstance();
		c1.add(Calendar.MONTH, 1);
		c1.set(Calendar.DAY_OF_MONTH, 1);
		firstnext = mat.format(c1.getTime());
		return firstnext;
	}

	public static String getlastnext() {
		String lastnext;
		Calendar ca1 = Calendar.getInstance();
		ca1.add(Calendar.MONTH, 1);
		ca1.set(Calendar.DAY_OF_MONTH, ca1.getActualMaximum(Calendar.DAY_OF_MONTH));
		lastnext = mat.format(ca1.getTime());
		return lastnext;
	}
}
